<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Product Review Export
 */

namespace Amasty\ProductReviewExport\Setup\Patch\Data;

use Amasty\ProductReviewExport\Setup\Operation\AddProfile;
use Magento\Framework\Setup\Patch\DataPatchInterface;

class ExportReviewProfile implements DataPatchInterface
{
    /**
     * @var AddProfile
     */
    private $addProfile;

    public function __construct(
        AddProfile $addProfile
    ) {
        $this->addProfile = $addProfile;
    }

    public static function getDependencies(): array
    {
        return [];
    }

    public function getAliases(): array
    {
        return [];
    }

    public function apply(): ExportReviewProfile
    {
        $this->addProfile->saveProfile();

        return $this;
    }
}
